#include "stdafx.h"
#include <iostream>
#include <string>
#include <list>
#include <initializer_list>
#include <sstream>


using namespace std;

// **********************************************************************
// ** 1) nullptr
void function( char *pData )
{
	cout << "Ich bin in \"function( char *pData )\"\n";
}

void function( int value )
{
	cout << "Ich bin in \"function( int value )\"\n";
}

// **********************************************************************
// ** 3) override und final
class Basis // final
{
private:
	int	_value;

public:
	virtual void testFunction( char *pData ) //final
	{
		cout << "Jetzt bin ich in der Funktion der Basisklasse\n";
	}

public:
	Basis()
	{
		_value = 7;
	}

	// ** Copy-Konstruktor
	//Basis( const Basis &origin )
	//{
	//	_value = origin._value;
	//}

	//	Basis( const Basis & ) = delete;

	//
	//private:
	//	Basis( const Basis & )
	//	{
	//	}
};

class Abgeleitet : public Basis
{
private:
	int _testValue = 123;					// <- nonstatic data member initializers

public:
	//void testFunction( int value ) override
	void testFunction( char *pData ) override
	{
		cout << "Und jetzt bin ich in der Funktion der abgleiteten Klasse\n";
	}
};



class MitListe
{
private:
	template< typename _Type> void fillIn( const initializer_list<_Type> &init )
	{
		for( auto wert : init )
		{
			stringstream helper;
			helper << wert;
			_werte.push_back( helper.str() );
		}
	}

public:
	MitListe( initializer_list<double> init )
	{
		fillIn<double>( init );
	}

	MitListe( initializer_list<int> init )
	{
		fillIn<int>( init );
	}

private:
	list<string> _werte;
};


struct ImplicitAllowed
{
public:
	ImplicitAllowed( int value )
	{
		_value = value;
	}

	operator int( void ) const
	{
		return _value;
	}
private:
	int _value = 9999;
};

struct OnlyExplicit
{
public:
	explicit OnlyExplicit( int value )
	{
		_value = value;
	}

	explicit operator int( void ) const
	{
		return _value;
	}
private:
	int _value = 9999;
};



int _tmain( int argc, _TCHAR* argv[] )
{
	// **********************************************************************
	// ** 1) nullptr
	function( NULL );
	function( nullptr );

	// **********************************************************************
	// ** 2) for_each und auto (inkl. >>)
	list<string> zeilen;
	zeilen.push_back( "Willkommen bei der" );
	zeilen.push_back( ".net User Group Austria." );
	zeilen.push_back( "Das ist der Vortrag ber" );
	zeilen.push_back( "modern C++." );

	for( auto &zeile : zeilen )
	{
		cout << zeile << endl;
	}

	/*for( list<string>::iterator meinIterator = zeilen.begin() ; meinIterator != zeilen.end() ; meinIterator++ )
	{
		cout << *(meinIterator) << endl;
	}
*/
	// **********************************************************************
	// ** 3) override, final, evntl const
	Abgeleitet subclass;
	subclass.testFunction( NULL );

	// **********************************************************************
	// ** 4) explicit delete member functions
	//	Abgeleitet dieKopie = subclass;

	// **********************************************************************
	// ** 5) raw string literals
	cout << "\n\n";

	string normal = "First line.\nSecond line.\nEnd of message.\n";
	string raw = R"(First line.\nSecond line.\nEnd of message.\n)";

	cout << normal;
	cout << raw;

	cout << "\n\n";

	// ** Bringt Vorteile bei Dateinamen und/oder regular expressions
	// string raw_pattern = R"((\+|-)?[[:digit:]]+)";
	// regex integer( raw_pattern );

	// **********************************************************************
	// ** 6) initializer list
	int arrayTest[] = { 10, 20, 30, 40, 50 };
	MitListe initDoubleTest{ 33.44, 22.44, 22.44, 88.67 };
	MitListe initIntTest{ 12, 34, 56, 67, 89 };

	// **********************************************************************
	// ** 7) explicit conversion operator
	// A has no explicit ctor / conversion, everything is fine
	ImplicitAllowed a1 = 1;
	ImplicitAllowed a2( 2 );
	ImplicitAllowed a3{ 3 };
	int na1 = a1;
	int na2 = static_cast<int>(a1);

//	OnlyExplicit b1 = 1; // Error: implicit conversion from int to B
	OnlyExplicit b2( 2 ); // OK: explicit constructor call
	OnlyExplicit b3{ 3 }; // OK: explicit constructor call
//	int nb1 = b2; // Error: implicit conversion from B to int
	int nb2 = static_cast<int>(b2); // OK: explicit cast

	return 0;
}

// C++11 feels like a new language.




