#include "stdafx.h"
#include <iostream>

#include "..\demo.jukebox\Song.h"
#include "..\demo.jukebox\Playlist.h"

using namespace std;
using namespace JukeBox;

int _tmain(int argc, _TCHAR* argv[])
{
	// ****************************************
	// ** 1) basic syntax  C#: () => { .... }
	auto func = []()
	{ 
		cout << "Hallo Welt\n"; 
	};

	// ** aufruf
	func();


	// *******************************************************************
	// ** 2) std::function fr lambdas als Parameter
	Playlist disco;
	disco.append( make_shared<Song>( "aaa", "bbb" ) );
	disco.append( make_shared<Song>( "ccc", "dddd" ) );
	disco.append( make_shared<Song>( "eee", "fff" ) );

	cout << "\n\nUnd die Party beginnt...\n\n";

	disco.play( []( const Song& lied )
	{
		cout << "Es laeuft: " << lied.getTitle() << " von " << lied.getArtist() << "\n";
	} );

	cout << "\n\nUnd die Party ist fertig.\n\n";


	// *******************************************************************
	// ** 3) Capturing Variables
	int countByValue = 0, countByRef = 0;
	disco.play( [countByValue, &countByRef]( const Song& lied ) mutable
	{
		countByValue++;  // daffr brauch ich das mutable
		countByRef++;
	} );

	// * die Parameterliste ist optional. Keine Default Arguments, keine VarArgs,...
	// * Capture Variables, References, default caputre mode am Anfang [=,  oder [&, 
	// * mutable, throw(), maintains state (das macht ein FuncPointer nicht)
	// ** der return-type kann weggelassen werden, wenn nur 1 return drinnen ist, oder
	// ** nichts zurckgegeben wird.
	auto addieren = []( int x, int y ) { return x + y; };
	auto ergebnis = addieren( 7, 9 );

	return 0;
}

// http://msdn.microsoft.com/en-us/library/vstudio/dd293608.aspx
