#include "stdafx.h"
#include <string>
#include <iostream>

using namespace std;

// ******************************************************************************************************
template<typename _Type> _Type swap( _Type value )
{
	static_assert(false, "Swap kann nur fr Datentype aufgerufen werde die spezialisiert worden sind!");
}

template<> short swap( short value )
{
	return (value << 8) | ((value >> 8) & 0xFF);
}

template<> unsigned short swap( unsigned short value )
{
	return (value << 8) | (value >> 8);
}

template<> int swap( int value )
{
	value = ((value << 8) & 0xFF00FF00) | ((value >> 8) & 0xFF00FF);
	return (value << 16) | ((value >> 16) & 0xFFFF);
}

template<> unsigned int swap( unsigned int value )
{
	value = ((value << 8) & 0xFF00FF00) | ((value >> 8) & 0xFF00FF);
	return (value << 16) | (value >> 16);
}

template<> long long swap( long long value )
{
	value = ((value << 8) & 0xFF00FF00FF00FF00ULL) | ((value >> 8) & 0x00FF00FF00FF00FFULL);
	value = ((value << 16) & 0xFFFF0000FFFF0000ULL) | ((value >> 16) & 0x0000FFFF0000FFFFULL);
	return (value << 32) | ((value >> 32) & 0xFFFFFFFFULL);
}

template<> unsigned long long swap( unsigned long long value )
{
	value = ((value << 8) & 0xFF00FF00FF00FF00ULL) | ((value >> 8) & 0x00FF00FF00FF00FFULL);
	value = ((value << 16) & 0xFFFF0000FFFF0000ULL) | ((value >> 16) & 0x0000FFFF0000FFFFULL);
	return (value << 32) | (value >> 32);
}

// ******************************************************************************************************
// ** templates auch mit Werten (anstatt nur mit Typen)
template<bool _optimizedVersion> void function( void )
{
	static_assert(false, "Da stimmt was nicht");
}

template<> void function<true>( void )
{
	cout << "optimierte Implementierung\n";
}

template<> void function<false>( void )
{
	cout << "normale Implementierung\n";
}

template<typename _Type> struct optimize_trait
{
	static const bool value = false;
};

template<> struct optimize_trait<double>
{
	static const bool value = true;
};

class TestKlasse
{
};

template<> struct optimize_trait<TestKlasse>
{
	static const bool value = true;
};

template<typename _Type> inline void genericCall( const _Type &value )
{
	function<optimize_trait<_Type>::value>();
}

// ** default template arguments
template<typename _Type1, typename _Type2 = double> void doWithDefaultTemplate( const _Type1 &value1, const _Type2 &value2 = 56 )
{
	cout << "Value1 ist vom Typ: \"" << typeid(value1).name() << "\" und Value2 ist vom Typ: \"" << typeid(value2).name() << "\"\n";
}

// ** 4) Alias-Templates
template <class CharT> using mystring = basic_string<CharT, std::char_traits<CharT>>;


int _tmain(int argc, _TCHAR* argv[])
{
	// ******************************************************
	// ** 1) partielle Spezialisierung
	int shortLen = sizeof(short);
	int intLen = sizeof(int);
	int longlongLen = sizeof(long long);

	short shortTest = 0x1234;
	int intTest = 0x12345678;
	long long llTest = 0x1234567890ABCDEFLL;

	shortTest = swap( shortTest );  // -> swap<short>
	intTest = swap( intTest );		// -> swap<int>
	llTest = swap( llTest );		// -> swap<long long>

	// ** -> Compile-Time Prfung mit static_assert
	double doubleTest = 45.34;
//	swap( doubleTest );					// -> default


	// ********************************************************
	// ** 2) traits
	TestKlasse instanz;
	genericCall( instanz );
	genericCall( doubleTest );
	genericCall( intTest );

	string dasIstNurZurAnschauung;

	// ********************************************************
	// ** 3) Default-Template-Arguments
	doWithDefaultTemplate<int>( 17 );
	doWithDefaultTemplate<int, long>( 12, 3456 );

	// ********************************************************
	// ** 4) Alias-Templates
	mystring<char> meiner;
	meiner = "Hallo Meister";

	return 0;
}

