#include "stdafx.h"
#include "Playlist.h"
#include "Song.h"


namespace JukeBox
{
	void Playlist::append( std::shared_ptr<Song> song )
	{
		_songs.push_back( song );
	}

	void Playlist::play( std::function<void( const Song& )> player )
	{
		for( auto pSong : _songs )
		{
			player( *pSong );
		}
	}

	std::list<std::shared_ptr<Song>> Playlist::getSongsForArtist( const std::string &artist )
	{
		std::list<std::shared_ptr<Song>> result;
		for( auto pSong : _songs )
		{
			if( pSong->getArtist() == artist )
			{
				result.push_back( pSong );
			}
		}

		return result;
	}

	void Playlist::removeSongsForArtist( const std::string &artist )
	{
		_songs.remove_if( [&artist]( const std::shared_ptr<Song> pSong )
		{
			return (pSong->getArtist() == artist);
		} );
	}

	int Playlist::removeSong( const std::string &title, const std::string &artist )
	{
		int removedCount = 0;
		_songs.remove_if( [&artist, &title, &removedCount]( const std::shared_ptr<Song> pSong )
		{
			bool found = ((pSong->getArtist() == artist) && (pSong->getTitle() == title));
			removedCount += (found == true) ? 1 : 0;
			return found;
		} );

		return removedCount;
	}
}
