#pragma once
#include <list>
#include <functional>
#include <memory>

namespace JukeBox
{
	class Song;

	class Playlist
	{

	public:
		void append( std::shared_ptr<Song> song );
		void play( std::function<void( const Song& )> player );

	public:
		std::list<std::shared_ptr<Song>> getSongsForArtist( const std::string &artist );
		void removeSongsForArtist( const std::string &artist );
		int removeSong( const std::string &title, const std::string &artist );

	public:
		std::size_t size( void ) const
		{
			return _songs.size();
		}

	private:
		std::list<std::shared_ptr<Song>> _songs;
	};
}

