#pragma once
#include <string>

namespace JukeBox
{
	class Song
	{
	public:
		Song( const std::string &title, const std::string &artist ) :
		Song( title.c_str( ), artist.c_str( ) )	
		{
		}

		Song( const char *pTitle, const char *pArtist ) :
			_title( pTitle ),
			_artist( pArtist )
		{
		}

	public:
		Song() = delete;
		virtual ~Song()
		{
		}

	public:
		const std::string& getTitle( void ) const
		{
			return _title;
		}

		const std::string& getArtist( void ) const
		{
			return _artist;
		}

	private:
		std::string _title;
		std::string _artist;
	};
}

