#include "stdafx.h"
#include "CppUnitTest.h"
#include "..\demo.jukebox\Song.h"
#include "..\demo.jukebox\Playlist.h"

using namespace std;
using namespace JukeBox;
using namespace Microsoft::VisualStudio::CppUnitTestFramework;

namespace demounittests
{
	TEST_CLASS( Playlist_Test )
	{
	public:
		TEST_METHOD( append_remove )
		{
			Playlist disco;
			disco.append( make_shared<Song>( "aaa", "bbb" ) );
			disco.append( make_shared<Song>( "ccc", "bbb" ) );
			disco.append( make_shared<Song>( "eee", "fff" ) );

			Assert::AreEqual<size_t>( disco.size(), 3, L"In der Playliste sind nicht 3 Elemente." );

			auto vonDem = disco.getSongsForArtist( "bbb" );
			Assert::AreEqual<size_t>( vonDem.size(), 2, L"Es sollten genau 2 vonDem da sein." );

			disco.removeSongsForArtist( "bbb" );
			Assert::AreEqual<size_t>( disco.size(), 1, L"Das Lschen hat nicht richtig funktioniert." );
			auto nochWasVonDem = disco.getSongsForArtist( "bbb" );
			Assert::AreEqual<size_t>( nochWasVonDem.size(), 0, L"VonDem sollte eigentlich nichts mehr da sein." );
		}

		TEST_METHOD( geht_voll_schief )
		{
			Playlist disco;
			Assert::AreEqual<size_t>( 3, disco.size(),  L"Fehler, Fehler, Fehler" );
		}

		TEST_METHOD( partial )
		{
			Playlist disco;
			disco.append( make_shared<Song>( "aaa", "bbb" ) );
			disco.append( make_shared<Song>( "ccc", "bbb" ) );
			disco.append( make_shared<Song>( "eee", "fff" ) );

			int removedCount = disco.removeSong( "Dancing Queen", "Abba" );
			Assert::AreEqual<size_t>( removedCount, 0, L"Was tut Abba da in meiner Playlist?" );
		}
	};
}